package com.ibm.rational.report.oda.reqpro.ui.impl;

//import org.eclipse.datatools.enablement.oda.xml.ui.wizards.XMLSelectionPageHelper;
import java.util.Properties;

import org.eclipse.datatools.connectivity.oda.OdaException;
import org.eclipse.datatools.connectivity.oda.design.ui.pages.impl.DefaultDataSourcePageHelper;
import org.eclipse.datatools.connectivity.oda.design.ui.pages.impl.DefaultDataSourcePropertyPage;
import org.eclipse.datatools.connectivity.oda.design.ui.pages.impl.DefaultDataSourceWizardPage;
import org.eclipse.datatools.enablement.oda.xml.ui.wizards.Constants;
import org.eclipse.jface.preference.PreferencePage;
import org.eclipse.jface.wizard.WizardPage;
import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.ScrolledComposite;
import org.eclipse.swt.events.ControlAdapter;
import org.eclipse.swt.events.ControlEvent;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.widgets.Composite;
/**
 * @author Suryakant Choudhary
 * @since 1.0
 */
public class ReqProGuiHelper extends DefaultDataSourcePageHelper {

	private static String sXMLFileLocation = "";
	private static String sSchemaFileLocation = "";
	private static String sXMLEncoding = "";
	private static RESTDataSource dataSource = null;
	public static DefaultDataSourceWizardPage dataSourceWizardPage = null;
	
	static final String sMESSAGE = ReqProDriverResourceBundle.getString("GENERATEURLMSG"); 
        //"Generate the URL for Defining Data Source";
	
	public ReqProGuiHelper(DefaultDataSourceWizardPage page ) {
		super(page);
		dataSourceWizardPage = page;
		
		
		
	}

	public ReqProGuiHelper( DefaultDataSourcePropertyPage page )
	   {
		super(page);
	   }
	
	protected void createCustomControl( Composite parent ) throws OdaException
    {
		super.setMessage(sMESSAGE, 0);
		
		// Create a ScrolledComposite as the child of the parent wizard page.
    	final ScrolledComposite scrolledComposite = new ScrolledComposite( parent, SWT.V_SCROLL | SWT.H_SCROLL | SWT.BORDER );
    	scrolledComposite.setExpandVertical( true );
    	scrolledComposite.setExpandHorizontal( true );
    	
    	// Create a Composite with the ScrolledComposite as the parent.
    	//final Composite content = new Composite( scrolledComposite, SWT.NONE );
    	dataSource = new RESTDataSource(scrolledComposite,SWT.NONE);
    	
    	scrolledComposite.setContent( dataSource );
    	
    	dataSource.initialize();
    	
    	// Set up control listener to monitor the resizing of the properties pane.
    	scrolledComposite.addControlListener( 
    			new ControlAdapter() 
    			{
    				public void controlResized( ControlEvent e ) 
    				{
    					Rectangle r = scrolledComposite.getClientArea();
    					scrolledComposite.setMinSize( dataSource.computeSize( r.width, SWT.DEFAULT ));
    				}
    			});

    	
    }
	
	protected void initCustomControl( Properties rReqProprofileProps )
	{
		 if( rReqProprofileProps == null || rReqProprofileProps.isEmpty() || 
				 sXMLFileLocation == null )
		            return;     
		        
		        String sXMLFilePath = rReqProprofileProps.getProperty( Constants.CONST_PROP_FILELIST );
		        if( sXMLFilePath == null )
		        	sXMLFilePath = "";
		       
		        sXMLFileLocation = sXMLFilePath ;		        
		        	        
		       
	}
	
	  protected Properties collectCustomProperties( Properties pReqProprops )
	    {
	        if( pReqProprops == null )
	        	pReqProprops = new Properties();
	        
	        // set custom driver specific properties
	        pReqProprops.setProperty( Constants.CONST_PROP_FILELIST,
	        		sXMLFileLocation );
	        pReqProprops.setProperty( Constants.CONST_PROP_SCHEMA_FILELIST,
	        		sSchemaFileLocation );
	        pReqProprops.setProperty( Constants.CONST_PROP_ENCODINGLIST, sXMLEncoding );
			return pReqProprops;
	    }
	  
	  public static void setGeneratedURL(String URL)
	  {
		  sXMLFileLocation = URL;
		  sSchemaFileLocation = "";
		  
	  }

}
